			IMPORT _main	
			AREA "C$$init",CODE,READONLY
; C$$init is set to 0 almost always
; 0x00 - 0x1F contains the interrupt vector entries
;
					
	LDR PC,cstart_addr	; reset
	SUB PC,PC,#8		; undefined instruction
	SUB PC,PC,#8		; software interrupt
	SUB PC,PC,#8		; prefetch data abort
	SUB PC,PC,#8		; data abort
	SUB PC,PC,#8		; not used
	LDR PC,[PC,#-0xFF0]		; IRQ
	SUB PC,PC,#8		; FIQ
; generic startup file "body," to be concatenated with crtXXvec.s
; vector file
;
; 0x20 - 0x3F contains the addresses of the handlers
cstart_addr:	DCD _cstart
			

			;User defined code for vector initialization or any other functions 

			AREA "C$$code",CODE,READONLY
			EXPORT _cstart
			EXPORT _exit
			EXPORT $icc$ROM_ADDR
			EXPORT $icc$RAM_ADDR
			EXPORT $icc$DATA_SIZE
			EXPORT $icc$VENROM_ADDR
			EXPORT $icc$VENRAM_ADDR
			EXPORT $icc$VENDATA_SIZE

			IMPORT $icc$SP_VALUE
;			IMPORT $icc$IRQ_VAL
;			IMPORT $icc$USR_VAL
			
			EXPORT $icc$URAM_ADDR
			EXPORT $icc$UDATA_SIZE

$icc$ROM_ADDR:		DCD 0  ; ROM address where initialized data(if present)	is present
$icc$RAM_ADDR:		DCD 0  ; Initialized data memory(RAM) address
$icc$DATA_SIZE:		DCD 0  ; Initialized data size	
$icc$URAM_ADDR:		DCD 0  ; Unitialized data memory(RAM) address
$icc$UDATA_SIZE:	DCD 0  ; Unitialized data size	
$icc$VENROM_ADDR:	DCD 0  
$icc$VENRAM_ADDR:	DCD 0  
$icc$VENDATA_SIZE:	DCD 0  

SP_VALUE:		DCD $icc$SP_VALUE
IRQ_VALUE:		DCD $icc$IRQ_VALUE
FIQ_VALUE: 		DCD $icc$FIQ_VALUE

_cstart:
; initialize uninitialized data memory ("bss") to Zero
			LDR R1,$icc$URAM_ADDR
			LDR R2,$icc$UDATA_SIZE
			MOVS R3,R2  
			BEQ _loop4
			MOV R5,#0x0
_LOOP3:
			SUBS R3,R3,#0x1
			STRB R5,[R1,R3]
			BNE _LOOP3
; copy initialized data from ROM memory to RAM memory
_loop4:
			LDR R0,$icc$ROM_ADDR
			LDR R1,$icc$RAM_ADDR
			LDR R2,$icc$DATA_SIZE
			MOVS R3,R2  
			;BEQ done_copy
			BEQ Ven_copy
_LOOP2:
			SUBS R3,R3,#0x1
			LDRB R5,[R0,R3]
			STRB R5,[R1,R3]
			BNE _LOOP2

Ven_copy:
			LDR R0,$icc$VENROM_ADDR
			LDR R1,$icc$VENRAM_ADDR
			LDR R2,$icc$VENDATA_SIZE
			MOVS R3,R2  
			BEQ done_copy
_LOOP4:
			SUBS R3,R3,#0x1
			LDRB R5,[R0,R3]
			STRB R5,[R1,R3]
			BNE _LOOP4
			
; initializes SPs
; stack layout
;
; high address:	FIQ stack
;               <FIQ stack size from the IDE/cmd file>
;               IRQ stack
;               <IRQ stack size from the IDE/cmd file>
;               Supervisor stack
; ...
; low memory
;
;
; if you wish to enable user mode, modify this file to give supervisor
; separate stack size and set the user stack below that
;
done_copy
    			; switch to FIQ Mode
            		msr cpsr_c,#0x11|0xC0
			LDR R13,SP_VALUE
			LDR R12,FIQ_VALUE
            		SUB R0,R13,R12	; adjust for FIQ stack
    			; switch to IRQ Mode
            		msr cpsr_c,#0x12|0xC0
			mov R13,R0
			LDR R12,IRQ_VALUE
            		SUB R0,R13,R12	; adjust for IRQ stack
        		; supervisor
            		msr cpsr_c,#0x13|0xC0
			mov R13,R0	; supervisor stack
			; call user program
			BL _main
_exit:
_loop:
			B _loop
